Index: CKEditor/branches/versions/3.5.x/_source/lang/uk.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/lang/uk.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/lang/uk.js	(revision 6050)
@@ -741,37 +741,37 @@
 		title		: 'Про CKEditor',
 		dlgTitle	: 'Про CKEditor',
-		moreInfo	: 'Щодо інформації з ліцензування завітайте до нашого сайту:',
+		moreInfo	: 'Щодо інформації з ліцензування завітайте на наш сайт:',
 		copy		: 'Copyright &copy; $1. Всі права застережено.'
 	},
 
 	maximize : 'Максимізувати',
-	minimize : 'Minimize', // MISSING
+	minimize : 'Мінімізувати',
 
 	fakeobjects :
 	{
 		anchor	: 'Якір',
-		flash	: 'Flash анімація',
+		flash	: 'Flash-анімація',
 		div		: 'Розрив сторінки',
-		unknown	: 'Невідомий об`єкт'
-	},
-
-	resize : 'Пересувайте для зміни розміру',
+		unknown	: 'Невідомий об\'єкт'
+	},
+
+	resize : 'Потягніть для зміни розмірів',
 
 	colordialog :
 	{
-		title		: 'Select color', // MISSING
-		options	:	'Color Options', // MISSING
-		highlight	: 'Highlight', // MISSING
-		selected	: 'Selected Color', // MISSING
-		clear		: 'Clear' // MISSING
-	},
-
-	toolbarCollapse	: 'Collapse Toolbar', // MISSING
-	toolbarExpand	: 'Expand Toolbar', // MISSING
+		title		: 'Обрати колір',
+		options	:	'Опції кольорів',
+		highlight	: 'Колір, на який вказує курсор',
+		selected	: 'Обраний колір',
+		clear		: 'Очистити'
+	},
+
+	toolbarCollapse	: 'Згорнути панель інструментів',
+	toolbarExpand	: 'Розгорнути панель інструментів',
 
 	bidi :
 	{
-		ltr : 'Text direction from left to right', // MISSING
-		rtl : 'Text direction from right to left' // MISSING
+		ltr : 'Напрямок тексту зліва направо',
+		rtl : 'Напрямок тексту справа наліво'
 	}
 };
Index: CKEditor/branches/versions/3.5.x/_source/lang/vi.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/lang/vi.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/lang/vi.js	(revision 6050)
@@ -732,5 +732,5 @@
 		dic_delete		: 'Xóa',
 		dic_rename		: 'Thay tên',
-		dic_info		: 'Initially the User Dictionary is stored in a Cookie. However, Cookies are limited in size. When the User Dictionary grows to a point where it cannot be stored in a Cookie, then the dictionary may be stored on our server. To store your personal dictionary on our server you should specify a name for your dictionary. If you already have a stored dictionary, please type it\'s name and click the Restore button.', // MISSING
+		dic_info		: 'Initially the User Dictionary is stored in a Cookie. However, Cookies are limited in size. When the User Dictionary grows to a point where it cannot be stored in a Cookie, then the dictionary may be stored on our server. To store your personal dictionary on our server you should specify a name for your dictionary. If you already have a stored dictionary, please type its name and click the Restore button.', // MISSING
 
 		aboutTab		: 'Thông tin'
Index: CKEditor/branches/versions/3.5.x/_source/lang/zh-cn.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/lang/zh-cn.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/lang/zh-cn.js	(revision 6050)
@@ -99,5 +99,5 @@
 		validateNumberFailed : '需要输入数字格式',
 		confirmNewPage	: '当前文档内容未保存,是否确认新建文档？',
-		confirmCancel	: '部分选项尚未保存，是否确认关闭对话框？',
+		confirmCancel	: '部分修改尚未保存，是否确认关闭对话框？',
 		options			: '选项',
 		target			: '目标窗口',
@@ -106,8 +106,8 @@
 		targetSelf		: '本窗口 (_self)',
 		targetParent	: '父窗口 (_parent)',
-		langDirLTR		: 'Left to Right (LTR)', // MISSING
-		langDirRTL		: 'Right to Left (RTL)', // MISSING
-		styles			: 'Style', // MISSING
-		cssClasses		: 'Stylesheet Classes', // MISSING
+		langDirLTR		: '从左到右 (LTR)',
+		langDirRTL		: '从右到左 (RTL)',
+		styles			: '样式',
+		cssClasses		: '样式类',
 
 		// Put the voice-only part of the label in the span.
@@ -201,5 +201,5 @@
 		type				: '标记类型',
 		start				: '开始序号',
-		validateStartNumber				:'List start number must be a whole number.', // MISSING
+		validateStartNumber				:'列表开始序号必须为整数格式',
 		circle				: '空心圆',
 		disc				: '实心圆',
@@ -288,8 +288,8 @@
 			hAlign			: '水平对齐',
 			vAlign			: '垂直对齐',
-			alignTop		: '顶端对齐',
-			alignMiddle		: '中间对齐',
-			alignBottom		: '底部对齐',
-			alignBaseline	: '基线对齐',
+			alignTop		: '顶端',
+			alignMiddle		: '中间',
+			alignBottom		: '底部',
+			alignBaseline	: '基线',
 			bgColor			: '背景颜色',
 			borderColor		: '边框颜色',
@@ -732,5 +732,5 @@
 		dic_delete		: '删除',
 		dic_rename		: '重命名',
-		dic_info		: 'Initially the User Dictionary is stored in a Cookie. However, Cookies are limited in size. When the User Dictionary grows to a point where it cannot be stored in a Cookie, then the dictionary may be stored on our server. To store your personal dictionary on our server you should specify a name for your dictionary. If you already have a stored dictionary, please type it\'s name and click the Restore button.', // MISSING
+		dic_info		: '一开始用户词典储存在 Cookie 中, 但是 Cookies 的容量是有限的, 当用户词典增长到超出 Cookie 限制时就无法再储存了, 这时您可以将词典储存到我们的服务器上. 要把您的个人词典到储存到我们的服务器上的话, 需要为您的词典指定一个名称, 如果您在我们的服务器上已经有储存有一个词典, 请输入词典名称并按还原按钮.',
 
 		aboutTab		: '关于'
@@ -742,5 +742,5 @@
 		dlgTitle	: '关于CKEditor',
 		moreInfo	: '访问我们的网站以获取更多关于协议的信息',
-		copy		: '版权所有 &copy; $1.'
+		copy		: 'Copyright &copy; $1. All rights reserved.'
 	},
 
@@ -751,7 +751,7 @@
 	{
 		anchor	: '锚点',
-		flash	: 'Flash',
+		flash	: 'Flash 动画',
 		div		: '分页',
-		unknown	: '位置对象'
+		unknown	: '未知对象'
 	},
 
@@ -772,6 +772,6 @@
 	bidi :
 	{
-		ltr : 'Text direction from left to right', // MISSING
-		rtl : 'Text direction from right to left' // MISSING
+		ltr : '文字方向为从左至右',
+		rtl : '文字方向为从右至左'
 	}
 };
Index: CKEditor/branches/versions/3.5.x/_source/lang/zh.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/lang/zh.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/lang/zh.js	(revision 6050)
@@ -732,5 +732,5 @@
 		dic_delete		: 'Delete', // MISSING
 		dic_rename		: 'Rename', // MISSING
-		dic_info		: 'Initially the User Dictionary is stored in a Cookie. However, Cookies are limited in size. When the User Dictionary grows to a point where it cannot be stored in a Cookie, then the dictionary may be stored on our server. To store your personal dictionary on our server you should specify a name for your dictionary. If you already have a stored dictionary, please type it\'s name and click the Restore button.', // MISSING
+		dic_info		: 'Initially the User Dictionary is stored in a Cookie. However, Cookies are limited in size. When the User Dictionary grows to a point where it cannot be stored in a Cookie, then the dictionary may be stored on our server. To store your personal dictionary on our server you should specify a name for your dictionary. If you already have a stored dictionary, please type its name and click the Restore button.', // MISSING
 
 		aboutTab		: '關於'
Index: CKEditor/branches/versions/3.5.x/_source/plugins/a11yhelp/dialogs/a11yhelp.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/a11yhelp/dialogs/a11yhelp.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/a11yhelp/dialogs/a11yhelp.js	(revision 6050)
@@ -7,5 +7,5 @@
 {
 	var lang = editor.lang.accessibilityHelp,
-		id = CKEDITOR.tools.getNextNumber();
+		id = CKEDITOR.tools.getNextId();
 
 	// CharCode <-> KeyChar.
@@ -126,6 +126,6 @@
 	function buildHelpContents()
 	{
-		var pageTpl = '<div class="cke_accessibility_legend" role="document" aria-labelledby="cke_' + id + '_arialbl" tabIndex="-1">%1</div>' +
-				'<span id="cke_' + id + '_arialbl" class="cke_voice_label">' + lang.contents + ' </span>',
+		var pageTpl = '<div class="cke_accessibility_legend" role="document" aria-labelledby="' + id + '_arialbl" tabIndex="-1">%1</div>' +
+				'<span id="' + id + '_arialbl" class="cke_voice_label">' + lang.contents + ' </span>',
 			sectionTpl = '<h1>%1</h1><dl>%2</dl>',
 			itemTpl = '<dt>%1</dt><dd>%2</dd>';
Index: CKEditor/branches/versions/3.5.x/_source/plugins/autogrow/plugin.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/autogrow/plugin.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/autogrow/plugin.js	(revision 6050)
@@ -15,6 +15,8 @@
 
 		// We can not use documentElement to calculate the height for IE (#6061).
-		if ( CKEDITOR.env.ie )
-			newHeight = doc.getBody().$.scrollHeight + 24;
+		// It is not good for IE Quirks, yet using offsetHeight would also not work as expected (#6408).
+		// We do the same for FF because of the html height workaround (#6341).
+		if ( CKEDITOR.env.ie || CKEDITOR.env.gecko )
+			newHeight = doc.getBody().$.scrollHeight + ( CKEDITOR.env.ie && CKEDITOR.env.quirks ? 0 : 24 );
 		else
 			newHeight = doc.getDocumentElement().$.offsetHeight;
@@ -42,7 +44,12 @@
 				editor.on( eventName, function( evt )
 				{
+					var maximize = editor.getCommand( 'maximize' );
 					// Some time is required for insertHtml, and it gives other events better performance as well.
-					if ( evt.editor.mode == 'wysiwyg' )
+					if ( evt.editor.mode == 'wysiwyg' &&
+						// Disable autogrow when the editor is maximized .(#6339)
+						( !maximize || maximize.state != CKEDITOR.TRISTATE_ON ) )
+					{
 						setTimeout( function(){ resizeEditor( evt.editor ); }, 100 );
+					}
 				});
 			}
Index: CKEditor/branches/versions/3.5.x/_source/plugins/basicstyles/plugin.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/basicstyles/plugin.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/basicstyles/plugin.js	(revision 6050)
@@ -30,13 +30,13 @@
 		};
 
-		var config = editor.config;
-		var lang = editor.lang;
+		var config = editor.config,
+			lang = editor.lang;
 
-		addButtonCommand( 'Bold'		, lang.bold			, 'bold'		, config.coreStyles_bold );
+		addButtonCommand( 'Bold'		, lang.bold		, 'bold'		, config.coreStyles_bold );
 		addButtonCommand( 'Italic'		, lang.italic		, 'italic'		, config.coreStyles_italic );
-		addButtonCommand( 'Underline'	, lang.underline	, 'underline'	, config.coreStyles_underline );
+		addButtonCommand( 'Underline'	, lang.underline		, 'underline'	, config.coreStyles_underline );
 		addButtonCommand( 'Strike'		, lang.strike		, 'strike'		, config.coreStyles_strike );
-		addButtonCommand( 'Subscript'	, lang.subscript	, 'subscript'	, config.coreStyles_subscript );
-		addButtonCommand( 'Superscript'	, lang.superscript	, 'superscript'	, config.coreStyles_superscript );
+		addButtonCommand( 'Subscript'	, lang.subscript		, 'subscript'	, config.coreStyles_subscript );
+		addButtonCommand( 'Superscript'	, lang.superscript		, 'superscript'	, config.coreStyles_superscript );
 	}
 });
Index: CKEditor/branches/versions/3.5.x/_source/plugins/bidi/plugin.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/bidi/plugin.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/bidi/plugin.js	(revision 6050)
@@ -6,9 +6,18 @@
 (function()
 {
-	var guardElements = { table:1, ul:1, ol:1, blockquote:1, div:1 };
-	var directSelectionGuardElements = {};
+	var guardElements = { table:1, tbody: 1, ul:1, ol:1, blockquote:1, div:1, tr: 1 },
+		directSelectionGuardElements = {},
+		// All guard elements which can have a direction applied on them.
+		allGuardElements = {};
 	CKEDITOR.tools.extend( directSelectionGuardElements, guardElements, { tr:1, p:1, div:1, li:1 } );
-
-	function onSelectionChange( evt )
+	CKEDITOR.tools.extend( allGuardElements, directSelectionGuardElements, { td:1 } );
+
+	function onSelectionChange( e )
+	{
+		setToolbarStates( e );
+		handleMixedDirContent( e );
+	}
+
+	function setToolbarStates( evt )
 	{
 		var editor = evt.editor,
@@ -19,22 +28,12 @@
 		useComputedState = useComputedState === undefined || useComputedState;
 
-		if ( useComputedState )
-		{
-			var selection = editor.getSelection(),
-				ranges = selection.getRanges();
-
-			selectedElement = ranges && ranges[ 0 ].getEnclosedNode();
-
-			// If this is not our element of interest, apply to fully selected elements from guardElements.
-			if ( !selectedElement || selectedElement
-					&& !( selectedElement.type == CKEDITOR.NODE_ELEMENT && selectedElement.getName() in directSelectionGuardElements )
-				)
-				selectedElement = getFullySelected( selection, guardElements );
-		}
+		// We can use computedState provided by the browser or traverse parents manually.
+		if ( !useComputedState )
+			selectedElement = getElementForDirection( path.lastElement );
 
 		selectedElement = selectedElement || path.block || path.blockLimit;
 
 		if ( !selectedElement || selectedElement.getName() == 'body' )
-			return CKEDITOR.TRISTATE_OFF;
+			return;
 
 		var selectionDir = useComputedState ?
@@ -44,8 +43,13 @@
 		editor.getCommand( 'bidirtl' ).setState( selectionDir == 'rtl' ? CKEDITOR.TRISTATE_ON : CKEDITOR.TRISTATE_OFF );
 		editor.getCommand( 'bidiltr' ).setState( selectionDir == 'ltr' ? CKEDITOR.TRISTATE_ON : CKEDITOR.TRISTATE_OFF );
-
-		var chromeRoot = editor.container.getChild( 1 );
-
-		if ( selectionDir != editor.lang.dir )
+	}
+
+	function handleMixedDirContent( evt )
+	{
+		var editor = evt.editor,
+			chromeRoot = editor.container.getChild( 1 ),
+			directionNode = getElementForDirection( evt.data.path.lastElement );
+
+		if ( directionNode && editor.lang.dir != directionNode.getComputedStyle( 'direction' ) )
 			chromeRoot.addClass( 'cke_mixed_dir_content' );
 		else
@@ -53,14 +57,65 @@
 	}
 
-	function switchDir( element, dir, editor )
-	{
-		var dirBefore = element.getComputedStyle( 'direction' ),
-			currentDir = element.getStyle( 'direction' ) || element.getAttribute( 'dir' ) || '';
-
+	/**
+	 * Returns element with possibility of applying the direction.
+	 * @param node
+	 */
+	function getElementForDirection( node )
+	{
+		while ( node && !( node.getName() in allGuardElements || node.is( 'body' ) ) )
+		{
+			var parent = node.getParent();
+			if ( !parent )
+				break;
+
+			node = parent;
+		}
+
+		return node;
+	}
+
+	function switchDir( element, dir, editor, database )
+	{
+		// Mark this element as processed by switchDir.
+		CKEDITOR.dom.element.setMarker( database, element, 'bidi_processed', 1 );
+
+		// Check whether one of the ancestors has already been styled.
+		var parent = element;
+		while ( ( parent = parent.getParent() ) && !parent.is( 'body' ) )
+		{
+			if ( parent.getCustomData( 'bidi_processed' ) )
+			{
+				// Ancestor style must dominate.
+				element.removeStyle( 'direction' );
+				element.removeAttribute( 'dir' );
+				return null;
+			}
+		}
+
+		var useComputedState = ( 'useComputedState' in editor.config ) ? editor.config.useComputedState : 1;
+
+		var elementDir = useComputedState ? element.getComputedStyle( 'direction' )
+			: element.getStyle( 'direction' ) || element.hasAttribute( 'dir' );
+
+		// Stop if direction is same as present.
+		if ( elementDir == dir )
+			return null;
+
+		// Reuse computedState if we already have it.
+		var dirBefore = useComputedState ? elementDir : element.getComputedStyle( 'direction' );
+
+		// Clear direction on this element.
 		element.removeStyle( 'direction' );
 
-		if ( currentDir.toLowerCase() == dir )
+		// Do the second check when computed state is ON, to check
+		// if we need to apply explicit direction on this element.
+		if ( useComputedState )
+		{
 			element.removeAttribute( 'dir' );
+			if ( dir != element.getComputedStyle( 'direction' ) )
+				element.setAttribute( 'dir', dir );
+		}
 		else
+			// Set new direction for this element.
 			element.setAttribute( 'dir', dir );
 
@@ -68,51 +123,33 @@
 		// the element and all its children, so it will get really reflected
 		// like a mirror. (#5910)
-		var dirAfter = element.getComputedStyle( 'direction' );
-		if ( dirAfter != dirBefore )
-		{
-			var range = new CKEDITOR.dom.range( element.getDocument() );
-			range.setStartBefore( element );
-			range.setEndAfter( element );
-
-			var walker = new CKEDITOR.dom.walker( range );
-
-			var node;
-			while ( ( node = walker.next() ) )
-			{
-				if ( node.type == CKEDITOR.NODE_ELEMENT )
-				{
-					// A child with dir defined is to be ignored.
-					if ( !node.equals( element ) && node.hasAttribute( 'dir' ) )
-					{
-						range.setStartAfter( node );
-						walker = new CKEDITOR.dom.walker( range );
-						continue;
-					}
-
-					// Switch the margins.
-					var marginLeft = node.getStyle( 'margin-right' ),
-						marginRight = node.getStyle( 'margin-left' );
-
-					marginLeft ? node.setStyle( 'margin-left', marginLeft ) : node.removeStyle( 'margin-left' );
-					marginRight ? node.setStyle( 'margin-right', marginRight ) : node.removeStyle( 'margin-right' );
-				}
-			}
-		}
+		if ( dir != dirBefore )
+			editor.fire( 'dirChanged', element );
 
 		editor.forceNextSelectionCheck();
-	}
-
-	function getFullySelected( selection, elements )
-	{
-		var selectedElement = selection.getCommonAncestor();
-		while( selectedElement.type == CKEDITOR.NODE_ELEMENT
-				&& !( selectedElement.getName() in elements )
-				&& selectedElement.getParent().getChildCount() == 1
-			)
-			selectedElement = selectedElement.getParent();
-
-		return selectedElement.type == CKEDITOR.NODE_ELEMENT
-			&& ( selectedElement.getName() in elements )
-			&& selectedElement;
+
+		return null;
+	}
+
+	function getFullySelected( range, elements )
+	{
+		var ancestor = range.getCommonAncestor( false, true );
+
+		range.enlarge( CKEDITOR.ENLARGE_BLOCK_CONTENTS );
+
+		if ( range.checkBoundaryOfElement( ancestor, CKEDITOR.START )
+				&& range.checkBoundaryOfElement( ancestor, CKEDITOR.END ) )
+		{
+			var parent;
+			while ( ancestor && ancestor.type == CKEDITOR.NODE_ELEMENT
+					&& ( parent = ancestor.getParent() )
+					&& parent.getChildCount() == 1
+					&& ( !( ancestor.getName() in elements ) || ( parent.getName() in elements ) )
+					)
+				ancestor = parent;
+
+			return ancestor.type == CKEDITOR.NODE_ELEMENT
+					&& ( ancestor.getName() in elements )
+					&& ancestor;
+		}
 	}
 
@@ -127,88 +164,63 @@
 			if ( ranges && ranges.length )
 			{
-				// Apply do directly selected elements from guardElements.
-				var selectedElement = ranges[ 0 ].getEnclosedNode();
-
-				// If this is not our element of interest, apply to fully selected elements from guardElements.
-				if ( !selectedElement || selectedElement
-						&& !( selectedElement.type == CKEDITOR.NODE_ELEMENT && selectedElement.getName() in directSelectionGuardElements )
-					)
-					selectedElement = getFullySelected( selection, guardElements );
-
-				if ( selectedElement )
+				var database = {};
+
+				// Creates bookmarks for selection, as we may split some blocks.
+				var bookmarks = selection.createBookmarks();
+
+				var rangeIterator = ranges.createIterator(),
+					range,
+					i = 0;
+
+				while ( ( range = rangeIterator.getNextRange( 1 ) ) )
 				{
-					if ( !selectedElement.isReadOnly() )
-						switchDir( selectedElement, dir, editor );
-				}
-				else
-				{
-					// Creates bookmarks for selection, as we may split some blocks.
-					var bookmarks = selection.createBookmarks();
+					// Apply do directly selected elements from guardElements.
+					var selectedElement = range.getEnclosedNode();
+
+					// If this is not our element of interest, apply to fully selected elements from guardElements.
+					if ( !selectedElement || selectedElement
+							&& !( selectedElement.type == CKEDITOR.NODE_ELEMENT && selectedElement.getName() in directSelectionGuardElements )
+						)
+						selectedElement = getFullySelected( range, guardElements );
+
+					if ( selectedElement && !selectedElement.isReadOnly() )
+						switchDir( selectedElement, dir, editor, database );
 
 					var iterator,
 						block;
 
-					for ( var i = ranges.length - 1 ; i >= 0 ; i-- )
+					// Walker searching for guardElements.
+					var walker = new CKEDITOR.dom.walker( range );
+
+					var start = bookmarks[ i ].startNode,
+						end = bookmarks[ i++ ].endNode;
+
+					walker.evaluator = function( node )
 					{
-						// Array of elements processed as guardElements.
-						var processedElements = [];
-						// Walker searching for guardElements.
-						var walker = new CKEDITOR.dom.walker( ranges[ i ] );
-						walker.evaluator = function( node ){
-							return node.type == CKEDITOR.NODE_ELEMENT
+						return !! ( node.type == CKEDITOR.NODE_ELEMENT
 								&& node.getName() in guardElements
 								&& !( node.getName() == ( enterMode == CKEDITOR.ENTER_P ) ? 'p' : 'div'
 									&& node.getParent().type == CKEDITOR.NODE_ELEMENT
-									&& node.getParent().getName() == 'blockquote'
-								);
-						};
-
-						while ( ( block = walker.next() ) )
-						{
-							switchDir( block, dir, editor );
-							processedElements.push( block );
-						}
-
-						iterator = ranges[ i ].createIterator();
-						iterator.enlargeBr = enterMode != CKEDITOR.ENTER_BR;
-
-						while ( ( block = iterator.getNextParagraph( enterMode == CKEDITOR.ENTER_P ? 'p' : 'div' ) ) )
-						{
-							if ( block.isReadOnly() )
-								continue;
-
-							var _break = 0;
-
-							// Check if block have been already processed by the walker above.
-							for ( var ii = 0; ii < processedElements.length; ii++ )
-							{
-								var parent = block.getParent();
-
-								while( parent && parent.getName() != 'body' )
-								{
-									if ( ( parent.$.isSameNode && parent.$.isSameNode( processedElements[ ii ].$ ) )
-											|| parent.$ == processedElements[ ii ].$ )
-									{
-										_break = 1;
-										break;
-									}
-									parent = parent.getParent();
-								}
-
-								if ( _break )
-									break;
-							}
-
-							if ( !_break )
-							{
-								switchDir( block, dir, editor );
-							}
-						}
-					}
-
-					editor.forceNextSelectionCheck();
-					// Restore selection position.
-					selection.selectBookmarks( bookmarks );
+									&& node.getParent().getName() == 'blockquote' )
+								// Element must be fully included in the range as well. (#6485).
+								&& node.getPosition( start ) & CKEDITOR.POSITION_FOLLOWING
+								&& ( ( node.getPosition( end ) & CKEDITOR.POSITION_PRECEDING + CKEDITOR.POSITION_CONTAINS ) == CKEDITOR.POSITION_PRECEDING ) );
+					};
+
+					while ( ( block = walker.next() ) )
+						switchDir( block, dir, editor, database );
+
+					iterator = range.createIterator();
+					iterator.enlargeBr = enterMode != CKEDITOR.ENTER_BR;
+
+					while ( ( block = iterator.getNextParagraph( enterMode == CKEDITOR.ENTER_P ? 'p' : 'div' ) ) )
+						!block.isReadOnly() && switchDir( block, dir, editor, database );
 				}
+
+				CKEDITOR.dom.element.clearAllMarkers( database );
+
+				editor.forceNextSelectionCheck();
+				// Restore selection position.
+				selection.selectBookmarks( bookmarks );
 
 				editor.focus();
Index: CKEditor/branches/versions/3.5.x/_source/plugins/button/plugin.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/button/plugin.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/button/plugin.js	(revision 6050)
@@ -71,5 +71,5 @@
 	{
 		var env = CKEDITOR.env,
-			id = this._.id = 'cke_' + CKEDITOR.tools.getNextNumber(),
+			id = this._.id = CKEDITOR.tools.getNextId(),
 			classes = '',
 			command = this.command, // Get the command name.
Index: CKEditor/branches/versions/3.5.x/_source/plugins/clipboard/dialogs/paste.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/clipboard/dialogs/paste.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/clipboard/dialogs/paste.js	(revision 6050)
@@ -11,8 +11,8 @@
 	function onPasteFrameLoad( win )
 	{
-		var doc =  new CKEDITOR.dom.document( win.document ),
+		var doc = new CKEDITOR.dom.document( win.document ),
 			docElement = doc.$;
 
-		doc.getById( "cke_actscrpt" ).remove();
+		doc.getById( 'cke_actscrpt' ).remove();
 
 		CKEDITOR.env.ie ?
Index: CKEditor/branches/versions/3.5.x/_source/plugins/clipboard/plugin.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/clipboard/plugin.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/clipboard/plugin.js	(revision 6050)
@@ -17,8 +17,8 @@
 			body = doc.getBody();
 
-		var	enabled = false;
+		var enabled = 0;
 		var onExec = function()
 		{
-			enabled = true;
+			enabled = 1;
 		};
 
@@ -164,14 +164,14 @@
 		var doc = this.document;
 
-		// Avoid recursions on 'paste' event for IE.
-		if ( CKEDITOR.env.ie && doc.getById( 'cke_pastebin' ) )
+		// Avoid recursions on 'paste' event or consequent paste too fast. (#5730)
+		if ( doc.getById( 'cke_pastebin' ) )
 			return;
 
 		// If the browser supports it, get the data directly
-		if (mode == 'text' && evt.data && evt.data.$.clipboardData)
+		if ( mode == 'text' && evt.data && evt.data.$.clipboardData )
 		{
 			// evt.data.$.clipboardData.types contains all the flavours in Mac's Safari, but not on windows.
 			var plain = evt.data.$.clipboardData.getData( 'text/plain' );
-			if (plain)
+			if ( plain )
 			{
 				evt.data.preventDefault();
@@ -255,5 +255,5 @@
 	function fixCut( editor )
 	{
-		if ( !CKEDITOR.env.ie || editor.document.$.compatMode == 'BackCompat' )
+		if ( !CKEDITOR.env.ie || CKEDITOR.env.quirks )
 			return;
 
@@ -349,5 +349,5 @@
 				{
 					var body = editor.document.getBody();
-					body.on( ( (mode == 'text' && CKEDITOR.env.ie) || CKEDITOR.env.webkit ) ? 'paste' : 'beforepaste',
+					body.on( ( (mode == 'text' && CKEDITOR.env.ie ) || CKEDITOR.env.webkit ) ? 'paste' : 'beforepaste',
 						function( evt )
 						{
Index: CKEditor/branches/versions/3.5.x/_source/plugins/colorbutton/plugin.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/colorbutton/plugin.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/colorbutton/plugin.js	(revision 6050)
@@ -188,5 +188,5 @@
 
 			// Render the "More Colors" button.
-			if ( config.colorButton_enableMore )
+			if ( config.colorButton_enableMore === undefined || config.colorButton_enableMore )
 			{
 				output.push(
@@ -201,5 +201,5 @@
 								lang.more,
 							'</a>' +
-						'</td>' );	// It is later in the code.
+						'</td>' );	// tr is later in the code.
 			}
 
@@ -213,10 +213,9 @@
 /**
  * Whether to enable the "More Colors..." button in the color selectors.
- * @default false
+ * @default true
  * @type Boolean
  * @example
  * config.colorButton_enableMore = false;
  */
-CKEDITOR.config.colorButton_enableMore = true;
 
 /**
Index: CKEditor/branches/versions/3.5.x/_source/plugins/colordialog/dialogs/colordialog.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/colordialog/dialogs/colordialog.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/colordialog/dialogs/colordialog.js	(revision 6050)
@@ -15,11 +15,9 @@
 		var dialog;
 
-		function spacer()
-		{
-			return {
-				type : 'html',
-				html : '&nbsp;'
-			};
-		}
+		var spacer =
+		{
+			type : 'html',
+			html : '&nbsp;'
+		};
 
 		function clearSelected()
@@ -31,9 +29,9 @@
 		function updateSelected( evt )
 		{
-			if ( ! (evt instanceof CKEDITOR.dom.event ) )
+			if ( ! ( evt instanceof CKEDITOR.dom.event ) )
 				evt = new CKEDITOR.dom.event( evt );
 
 			var target = evt.getTarget(),
-					color;
+				color;
 
 			if ( target.getName() == 'a' && ( color = target.getChild( 0 ).getHtml() ) )
@@ -43,5 +41,5 @@
 		function updateHighlight( event )
 		{
-			if ( ! (event instanceof CKEDITOR.dom.event ) )
+			if ( ! ( event instanceof CKEDITOR.dom.event ) )
 				event = event.data;
 
@@ -62,11 +60,9 @@
 		}
 
-		var onMouseout = $tools.addFunction( clearHighlight );
-
-		var onClick = updateSelected,
-				onClickHandler = CKEDITOR.tools.addFunction( onClick );
-
-		var onFocus = updateHighlight,
-				onBlur = clearHighlight;
+		var onMouseout = $tools.addFunction( clearHighlight ),
+			onClick = updateSelected,
+			onClickHandler = CKEDITOR.tools.addFunction( onClick ),
+			onFocus = updateHighlight,
+			onBlur = clearHighlight;
 
 		var onKeydownHandler = CKEDITOR.tools.addFunction( function( ev )
@@ -75,6 +71,6 @@
 			var element = ev.getTarget();
 			var relative, nodeToMove;
-			var keystroke = ev.getKeystroke();
-			var rtl = editor.lang.dir == 'rtl';
+			var keystroke = ev.getKeystroke(),
+				rtl = editor.lang.dir == 'rtl';
 
 			switch ( keystroke )
@@ -178,5 +174,5 @@
 		{
 			// Create the base colors array.
-			var aColors = ['00','33','66','99','cc','ff'];
+			var aColors = [ '00', '33', '66', '99', 'cc', 'ff' ];
 
 			// This function combines two ranges of three values from the color array into a row.
@@ -185,5 +181,5 @@
 				for ( var i = rangeA ; i < rangeA + 3 ; i++ )
 				{
-					var row = table.$.insertRow(-1);
+					var row = table.$.insertRow( -1 );
 
 					for ( var j = rangeB ; j < rangeB + 3 ; j++ )
@@ -288,5 +284,5 @@
 									}
 								},
-								spacer(),
+								spacer,
 								{
 									type : 'vbox',
@@ -321,5 +317,5 @@
 											}
 										},
-										spacer(),
+										spacer,
 										{
 											type : 'button',
Index: CKEditor/branches/versions/3.5.x/_source/plugins/contextmenu/plugin.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/contextmenu/plugin.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/contextmenu/plugin.js	(revision 6050)
@@ -40,5 +40,5 @@
 					//  for multiple range selecting (like Gecko), we use this key
 					//  combination as a fallback for triggering context-menu. (#4530)
-					if ( CKEDITOR.env.opera )
+					if ( CKEDITOR.env.opera && !( 'oncontextmenu' in document.body ))
 					{
 						var contextMenuOverrideButton;
@@ -111,4 +111,17 @@
 						this );
 
+					if ( CKEDITOR.env.opera )
+					{
+						// 'contextmenu' event triggered by Windows menu key is unpreventable,
+						// cancel the key event itself. (#6534)
+						element.on( 'keypress' , function ( evt )
+						{
+							var domEvent = evt.data;
+
+							if ( domEvent.$.keyCode == 0 )
+								domEvent.preventDefault();
+						});
+					}
+
 					if ( CKEDITOR.env.webkit )
 					{
